package dev.fitko.fitconnect.core;

import com.github.tomakehurst.wiremock.WireMockServer;
import com.github.tomakehurst.wiremock.client.WireMock;
import dev.fitko.fitconnect.api.config.ApplicationConfig;
import dev.fitko.fitconnect.api.config.Environment;
import dev.fitko.fitconnect.api.config.EnvironmentName;

import java.util.Map;

import static com.github.tomakehurst.wiremock.core.WireMockConfiguration.wireMockConfig;

public abstract class RestEndpointBase {

    public static WireMockServer wireMockServer;

    static {
        wireMockServer = new WireMockServer(wireMockConfig().dynamicPort());
        wireMockServer.start();
        WireMock.configureFor("localhost", wireMockServer.port());
    }

    protected ApplicationConfig getTestConfig(final String fakeBaseUrl) {

        final var envName = new EnvironmentName("TESTING");
        final var environments = Map.of(envName, new Environment(fakeBaseUrl, fakeBaseUrl, false));

        return ApplicationConfig.builder()
                .environments(environments)
                .activeEnvironment(envName)
                .build();
    }

}
